---
title: "Development actions history"
output: html_document
editor_options: 
  chunk_output_type: console
---

All commands that you use to use when developing packages...

# First time just after creating the project

- Fill the following chunk to create the DESCRIPTION of your package

```{r description}
# Describe your package
fusen::fill_description(
  pkg = here::here(),
  fields = list(
    Title = "A package about squirrels",
    Description = "Use Rmarkdown First method to build your package. Start your package with documentation. Everything can be set from a Rmarkdown file in your project.",
    `Authors@R` = c(
      person("Charlotte", "Lambert", email = "john@email.me", role = c("aut", "cre"))
    )
  )
)
# Define License with use_*_license()
usethis::use_mit_license("Charlotte Lambert")
```

# All-in-one function to deploy publicly on GitHub

Either use this GitHub all-in-one function or choose the steps one-by-one in the following sections.
See `vignette("share-on-a-github-website", package = "fusen")` for more information.

```{r, eval=FALSE}
# _All-in-one share of your package and its documentation on GitHub
fusen::init_share_on_github()
```


# Start using git

```{r, eval=FALSE}
usethis::use_git()
# Deal with classical files to ignore
usethis::git_vaccinate()
# Use main for primary branch
usethis::git_default_branch_rename()
```

# Set extra sources of documentation (execute only once)

```{r, eval=FALSE}
# Install a first time
remotes::install_local()
# README
usethis::use_readme_rmd()
# Code of Conduct
usethis::use_code_of_conduct("contact@fake.com")
# NEWS
usethis::use_news_md()
```

**From now, you will need to "inflate" your package at least once to be able to use the following commands. Let's go to your flat template, and come back here later if/when needed.**


# Package development tools
## Use once

```{r, eval=FALSE}
# Pipe
usethis::use_pipe()

# package-level documentation
usethis::use_package_doc()

# GitHub
# Add your credentials for GitHub
usethis::create_github_token()
gitcreds::gitcreds_set()

# _Or one step at a time
# Send your project to a new GitHub project (included in `init_share_on_github()`)
usethis::use_github()

usethis::use_git_remote("squirrels",
                        url = "https://gitlab.com/form_inter_certif2_oct2023/charlottel/squirrels.git",
                        overwrite = TRUE)

# Set Continuous Integration
# _GitHub (included in `init_share_on_github()`)
usethis::use_github_action_check_standard()
usethis::use_github_action("pkgdown")
usethis::use_github_action("test-coverage")
# _GitLab
gitlabr::use_gitlab_ci(type = "check-coverage-pkgdown")
```

## Use everytime needed

```{r, eval=FALSE}
# Simulate package installation
pkgload::load_all()

# Generate documentation and deal with dependencies
attachment::att_amend_desc()

# Check the package
devtools::check()

# Add a new flat template
fusen::add_flat_template("add")

# monter version - choisi les niveaux mais doit maintenir NEWS.md à la main pour noter les nouveautés. 
# peut aussi bien faire directement à la main dans NEWS et dans description, c'est aussi simple. 
usethis::use_version()

# tester le taux de couverture du package
covr::package_coverage()
# quelles parties ne sont pas couvertes
my_coverage <- covr::package_coverage()
covr::zero_coverage(my_coverage)

# pour créer une page exprès au sujet du taux de couverture des tests unitaires
covr::report()


```

# Share the package

```{r, eval=FALSE}
# set and try pkgdown documentation website locally
usethis::use_pkgdown() # only once !!!! créer le _yaml
pkgdown::build_site(override = list(destination = "inst/site")) # faire dans inst plutot que à la racine
# à faire à chaque update

# build the tar.gz with vignettes to share with others
devtools::build(vignettes = TRUE)

# Share your package and its documentation on GitHub
# usethis::create_github_token()
# gitcreds::gitcreds_set()
fusen::init_share_on_github()
```

# Mettre des données dans mon package

```{r, eval=FALSE}
# add data-raw/ dans le dossier du package
usethis::use_data_raw("data_act_squirrels") # creer le dossier et DATASET.R ; ensuite créer des scripts R pour les transformer

```

# check l'installation du package

```{r}
devtools::build(vignettes = TRUE) # construit le package au format tar.gz
remotes::install_local(path = "~/squirrels_0.0.0.9000.tar.gz") # installe le package depuis le format tar.gz
squirrels::launch_help()
```

# gestion des globalVariables

```{r}
checkhelper::print_globals(quiet = TRUE)
```

